unit Moodul9;
{
Programm teisendab matemaatilise avaldise postorder kujule
Programmeerimine II
9. lesanne
Erki Suurjaak
970772
LAP41
19.02.1999
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, str;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Teisenda: TButton;
    Lopeta: TButton;
    Label3: TLabel;
    procedure LopetaClick(Sender: TObject);
    procedure TeisendaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type ChariTyyp = set of char;

const Pluss   = '+';
      Miinus  = '-';
      Korda   = '*';
      Jagada  = ':';
      Vastand = '_';
      VasakSulg = '(';
      ParemSulg = ')';

      Tehted : ChariTyyp  = [Pluss, Miinus, Korda, Jagada, Vastand];
      Targid : ChariTyyp  = ['0'..'9', 'a'..'z'];
      Sulud  : ChariTyyp  = [VasakSulg, ParemSulg];


var Avaldis, PostOrder : string;

procedure TForm1.LopetaClick(Sender: TObject);
begin
     Form1.Close;
end;

function AvaldisOnKorrektne (var Avaldis : string) : boolean;
var i, j : integer;

begin
     AvaldisOnKorrektne := False;
     i := 0;
     if (Avaldis[1] in Tehted) and not (Avaldis[1] = Vastand) then exit;
     If Avaldis[length(Avaldis)] in Tehted then exit;
     for j := 1 to length (Avaldis) do
      begin
      if Avaldis[j] = Vastand then
       begin
       if j > 1 then if not (Avaldis[j - 1] = VasakSulg) then exit; 
       end
      else if Avaldis[j] in Tehted then
       begin
       If (Avaldis[j - 1] in Tehted) or (Avaldis[j - 1] = VasakSulg) then exit;
       end
      else if Avaldis[j] in Sulud then
       begin
       if Avaldis[j] = VasakSulg then
        begin
        if j > 1 then if not ((Avaldis[j - 1] in Tehted) or (Avaldis[j - 1] = VasakSulg))
         then exit;
        inc (i);
        end
       else
        begin
        if j > 1 then if not ((Avaldis[j - 1] in Targid) or (Avaldis[j - 1] = ParemSulg))
         then exit;
        dec (i);
        end;
       if i < 0 then exit;
       end
      else if Avaldis[j] in Targid then
       begin
       if Avaldis[j - 1] in Targid then exit;
       If Avaldis[j - 1] = ParemSulg then exit;
       end
      else exit;
      end;
     if not (i = 0) then exit;
     AvaldisOnKorrektne := True;
end;

procedure TeisendaAvaldis (Avaldis : string; var PostOrder : string);
var i : integer;
    t1, t2, o1 : string;
    Operandid, Operaatorid : pinu;

function Tahtsam (t1, t2 : char) : boolean;
begin
     Tahtsam := True;
     if t2 = Vastand then Tahtsam := False
     else if (t1 in ['+', '-']) and (t2 in ['*', ':']) then Tahtsam := False
     else if (t1 in ['+', '-']) and (t2 in ['+', '-']) then Tahtsam := False;
end;

begin
     Loo (Operandid);
     Loo (Operaatorid);
     Avaldis := VasakSulg + Avaldis + ParemSulg;
     for i := 1 to Length(Avaldis) do
      begin
      if (Avaldis[i] in Targid) or (Avaldis[i] in Sulud) then
       begin
       if not (Avaldis[i] = ParemSulg) then Push (Operandid, Avaldis[i])
       else
        begin
        while not (Operandid^.J2rg^.Number[1] = VasakSulg)
         and (Operaatorid^.Number <> Vastand) do
         begin
         Pop (Operandid, t1);
         Pop (Operandid, t2);
         Pop (Operaatorid, o1);
         if (t1[length(t1)] in Tehted) xor (t2[length(t2)] in Tehted) then
          begin
          if length(t1) > length(t2) then t1 := t2 + t1 else t1 := t1 + t2;
          end
         else if (t1[length(t1)] in Tehted) and (t2[length(t2)] in Tehted) then
          begin
          t1 := t1 + t2;
          end
         else t1 := t1 + t2;
         t1 := t1 + o1;
         Push (Operandid, t1);
         end;
        If (Operaatorid <> nil) and (Operaatorid^.Number = Vastand) then
         begin
         Pop (Operandid, t1);
         Pop (Operaatorid, o1);
         t1 := t1 + o1;
         Push (Operandid, t1);
         end;
        Pop (Operandid, t1);
        Pop (Operandid, t2);
        Push (Operandid, t1);
        end;
       end
      else
       begin
       begin
       while (Operaatorid <> nil) and (Operaatorid^.Number <> Vastand)
         and (Operandid^.Number <> VasakSulg) and (Operandid^.J2rg^.Number <> VasakSulg)
         and not (Tahtsam (Avaldis[i], Operaatorid^.Number[1])) do
        begin
        Pop (Operandid, t1);
        Pop (Operandid, t2);
        Pop (Operaatorid, o1);
        if (t1[length(t1)] in Tehted) xor (t2[length(t2)] in Tehted) then
         begin
         if length(t1) > length(t2) then t1 := t2 + t1 else t1 := t1 + t2;
         end
        else if (t1[length(t1)] in Tehted) and (t2[length(t2)] in Tehted) then
         begin
         t1 := t1 + t2;
         end
        else t1 := t1 + t2;
        t1 := t1 + o1;
        Push (Operandid, t1);
        end;
       if (Operaatorid <> nil) and (Operaatorid^.Number = Vastand)
         and (Operandid^.j2rg^.Number <> VasakSulg) then
        begin
        Pop (Operandid, t1);
        Pop (Operaatorid, o1);
        t1 := t1 + o1;
        Push (Operandid, t1);
        end;
       Push (Operaatorid, Avaldis[i]);
       end;
       end;
      end;
     while Operaatorid <> nil do
      begin
      Pop (Operandid, t1);
      Pop (Operaatorid, o1);
      if o1 <> Vastand then
       begin
       Pop (Operandid, t2);
       if (t1[length(t1)] in Tehted) xor (t2[length(t2)] in Tehted) then
        begin
        if length(t1) > length(t2) then t1 := t2 + t1 else t1 := t1 + t2;
        end
       else if (t1[length(t1)] in Tehted) and (t2[length(t2)] in Tehted) then
        begin
        t1 := t1 + t2;
        end
       else t1 := t1 + t2;
       end;
       t1 := t1 + o1;
       Push (Operandid, t1);
      end;

     Pop (Operandid, PostOrder);
     Kinga (Operandid);
     Kinga (Operaatorid);
end;



procedure TForm1.TeisendaClick(Sender: TObject);

begin
     Avaldis := Edit1.Text;
     if Length(Avaldis) = 0 then exit;
     PostOrder := '';
     if AvaldisOnKorrektne (Avaldis) then TeisendaAvaldis (Avaldis, PostOrder)
     else ShowMessage ('Sisestatud avaldis ei ole korrektne.');
     Edit2.Text := PostOrder;
end;


end.
