Unit Prog2_3M;

{
Kahendpuu moodul
Programmeerimine II
3. lesanne
Erki Suurjaak
970772
LAP41
19.02.1999
}

INTERFACE

TYPE BinPuu = ^Solm;


     Solm = RECORD
     Vaartus : word;
     Kordsus : word;
     Vasak   : BinPuu;
     Parem   : BinPuu;
     END;

VAR Arv, Elemente : word;


PROCEDURE TeeTyhiPuu (Var Vark : BinPuu);
PROCEDURE LisaElement (Lisatav : Word; Var Vark : BinPuu);
PROCEDURE EemaldaElement (Eemaldatav : Word; var Vark : BinPuu);
PROCEDURE ValjastaJuur (Vark : BinPuu);
FUNCTION  ElementPuus (Element : Word; Vark : BinPuu):Boolean;
PROCEDURE LoendaElemendid (Vark : BinPuu);
PROCEDURE ValjastaInOrder (Vark : BinPuu);
PROCEDURE ValjastaPreOrder (Vark : BinPuu);
PROCEDURE ValjastaPostOrder (Vark : BinPuu);
PROCEDURE KustutaElemendid (var Vark : BinPuu);


IMPLEMENTATION


PROCEDURE TeeTyhiPuu (Var Vark : BinPuu);

begin
     Vark := Nil;
     Elemente := 0;
     Arv := 0;
end;



PROCEDURE LisaElement (Lisatav : Word; Var Vark : BinPuu);

begin
     if Vark = Nil then
      begin
      New (Vark);
      Inc (Arv);
      Vark^.Vasak := Nil;
      Vark^.Parem := Nil;
      Vark^.Kordsus := 1;
      Vark^.Vaartus := Lisatav;
      end
     else if Lisatav < Vark^.Vaartus then LisaElement (Lisatav, Vark^.Vasak)
     else if Lisatav > Vark^.Vaartus then LisaElement (Lisatav, Vark^.Parem)
     else
      begin
      Inc (Arv);
      Inc (Vark^.Kordsus);
      end;
end;


Procedure Tosta (Kust : BinPuu; var Kuhu : BinPuu);
begin
     If Kuhu = Nil then Kuhu := Kust
     else
      begin
      If Kust^.Vaartus > Kuhu^.Vaartus then Tosta (Kust, Kuhu^.Parem);
      If Kust^.Vaartus < Kuhu^.Vaartus then Tosta (Kust, Kuhu^.Vasak);
      end;
end;



PROCEDURE EemaldaElement (Eemaldatav : Word; var Vark : BinPuu);
var temp : BinPuu;

begin
     if Vark = Nil then writeln ('Elementi ', Eemaldatav, ' ei eksisteeri.')
     else if Eemaldatav < Vark^.Vaartus then EemaldaElement (Eemaldatav, Vark^.Vasak)
     else if Eemaldatav > Vark^.Vaartus then EemaldaElement (Eemaldatav, Vark^.Parem)
     else
      begin
      Tosta (Vark^.Vasak, Vark^.Parem);
      temp := Vark;
      Vark := Vark^.Parem;
      Dispose (temp);
      end;
end;



PROCEDURE ValjastaJuur (Vark : BinPuu);

begin
     if Vark = Nil then writeln ('Puu on thi.')
     else writeln (Vark^.Vaartus:5, '*', Vark^.Kordsus);
end;



FUNCTION ElementPuus (Element : Word; Vark : BinPuu):Boolean;

begin
     If Vark = Nil then ElementPuus := False
     else if Element < Vark^.Vaartus
          then ElementPuus := ElementPuus (Element, Vark^.Vasak)
     else If Element > Vark^.Vaartus
          then ElementPuus := ElementPuus (Element, Vark^.Parem)
     else ElementPuus := True;
end;



PROCEDURE LoendaElemendid (Vark : BinPuu);

begin
     If Vark <> Nil then
      begin
      LoendaElemendid (Vark^.Vasak);
      Inc (Elemente);
      LoendaElemendid (Vark^.Parem);
      end;
end;


PROCEDURE ValjastaInOrder (Vark : BinPuu);

begin
     If Vark <> NIL then
      begin
      ValjastaInOrder (Vark^.Vasak);
      writeln (Vark^.Vaartus:5, '*', Vark^.Kordsus);
      ValjastaInOrder (Vark^.Parem);
      end;
end;



PROCEDURE ValjastaPreOrder (Vark : BinPuu);

begin
     If Vark <> NIL then
      begin
      writeln (Vark^.Vaartus:5, '*', Vark^.Kordsus);
      ValjastaPreOrder (Vark^.Vasak);
      ValjastaPreOrder (Vark^.Parem);
      end;
end;



PROCEDURE ValjastaPostOrder (Vark : BinPuu);

begin
     If Vark <> Nil then
      begin
      ValjastaPostOrder (Vark^.Vasak);
      ValjastaPostOrder (Vark^.Parem);
      writeln (Vark^.Vaartus:5, '*', Vark^.Kordsus);
      end;
end;



PROCEDURE KustutaElemendid (var Vark : BinPuu);

begin
     If Vark <> Nil then
      begin
      If Vark^.Vasak <> Nil then KustutaElemendid (Vark^.Vasak);
      If Vark^.Parem <> Nil then KustutaElemendid (Vark^.Parem);
      Dispose (Vark);
      Vark := nil;
      end;
end;





END.
