Unit Prog2_4m;

{
Libakahendpuu moodul
Programmeerimine II
4. lesanne
Erki Suurjaak
970772
LAP41
19.02.1999
}

INTERFACE

CONST max = 255;


TYPE Solm = record
     Vaartus : word;
     Kordsus : word;
     Vasak   : word;
     Parem   : word;
     end;

     BinPuu = array[1..max] of Solm;


var Vark : BinPuu;
    Elemente, temp : word;


PROCEDURE TeeTyhiPuu (Var Koht : Word);
PROCEDURE LisaElement (Lisatav : Word; Var Koht : Word);
PROCEDURE EemaldaElement (Eemaldatav : Word; var Koht : Word);
PROCEDURE ValjastaJuur (Koht : word);
FUNCTION  ElementPuus (Element : Word; Koht : Word):Boolean;
PROCEDURE LoendaElemendid (Koht : Word);
PROCEDURE ValjastaInOrder (Koht : Word);
PROCEDURE ValjastaPreOrder (Koht : Word);
PROCEDURE ValjastaPostOrder (Koht : Word);
PROCEDURE KustutaElemendid (var Koht : Word);



IMPLEMENTATION


PROCEDURE TeeTyhiPuu (Var Koht : Word);

begin
     Koht := 0;
     temp := 0;
     Elemente  := 0;
end;


PROCEDURE LisaElement (Lisatav : Word; Var Koht : Word);

begin
     if Koht = 0 then
      begin
      Inc (temp);
      Koht := temp;
      Vark[Koht].Vaartus := Lisatav;
      Vark[Koht].Kordsus := 1;
      Vark[Koht].Vasak:=0;
      Vark[Koht].Parem:=0;
      end
      else if Lisatav < Vark[Koht].Vaartus then LisaElement (Lisatav, Vark[Koht].Vasak)
      else if Lisatav > Vark[Koht].Vaartus then LisaElement (Lisatav, Vark[Koht].Parem)
      else Inc (Vark[Koht].Kordsus);
end;


Procedure Tosta (Kust : Word; var Kuhu : Word);
begin
     If Kuhu = 0 then Kuhu := Kust
     else
      begin
      If Vark[Kust].Vaartus > Vark[Kuhu].Vaartus then Tosta (Kust, Vark[Kuhu].Parem);
      If Vark[Kust].Vaartus < Vark[Kuhu].Vaartus then Tosta (Kust, Vark[Kuhu].Vasak);
      end;
end;


PROCEDURE EemaldaElement (Eemaldatav : Word; var Koht : Word);

begin
     If Koht = 0 then writeln ('Element ', Eemaldatav, ' ei ole puus.')
     else if Eemaldatav < Vark[Koht].Vaartus then EemaldaElement (Eemaldatav, Vark[Koht].Vasak)
     else if Eemaldatav > Vark[Koht].Vaartus then EemaldaElement (Eemaldatav, Vark[Koht].Parem)
     else
      begin
      Tosta (Vark[Koht].Vasak, Vark[Koht].Parem);
      Koht := Vark[Koht].Parem;
      end;
end;


PROCEDURE ValjastaJuur (Koht : word);

begin
  if Koht > 0 then writeln (Vark[Koht].Vaartus, '*', Vark[Koht].Kordsus)
  else writeln ('Puu on thi.');
end;


FUNCTION  ElementPuus (Element : Word; Koht : Word):Boolean;

begin
     If Koht = 0 then ElementPuus := False
     else if Element < Vark[Koht].Vaartus then
       ElementPuus := ElementPuus (Element,Vark[Koht].Vasak)
     else If Element > Vark[Koht].Vaartus then
       ElementPuus := ElementPuus (Element,Vark[Koht].Parem)
     else ElementPuus:=True;
end;


PROCEDURE LoendaElemendid (Koht : Word);

begin
     If Koht <> 0 then
      begin
      LoendaElemendid (Vark[Koht].Vasak);
      Inc (Elemente);
      LoendaElemendid (Vark[Koht].Parem);
      end;
end;


PROCEDURE ValjastaInOrder (Koht : Word);

begin
     If Koht <> 0 then
      begin
      ValjastaInOrder (Vark[Koht].Vasak);
      writeln (Vark[Koht].Vaartus, '*', Vark[Koht].Kordsus);
      ValjastaInOrder (Vark[Koht].Parem);
      end;
end;


PROCEDURE ValjastaPreOrder (Koht : Word);

begin
     If Koht <> 0 then
      begin
      writeln (Vark[Koht].Vaartus, '*', Vark[Koht].Kordsus);
      ValjastaPreOrder (Vark[Koht].Vasak);
      ValjastaPreOrder (Vark[Koht].Parem);
      end;
end;


PROCEDURE ValjastaPostOrder (Koht : Word);

begin
     If Koht <> 0 then
      begin
      ValjastaPostOrder (Vark[Koht].Vasak);
      ValjastaPostOrder (Vark[Koht].Parem);
      writeln (Vark[Koht].Vaartus, '*', Vark[Koht].Kordsus);
      end;
end;


PROCEDURE KustutaElemendid (var Koht : Word);

begin
     Koht := 0;
     Elemente := 0;
     temp := 0;
end;





END.
