unit Unit1;

{
Programmeerimine II
10. lesanne
Erki Suurjaak
970772
LAP41
19.02.1999
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
    TKaart = class (TImage)
     public
          Vaartus : integer;
     end;
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Timer1: TTimer;
    PildiMassiiv: TImageList;


    procedure PaneArvutiKaart (var Pandav : shortint);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TihiDragOver (Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TihiDragDrop (Sender, Source: TObject; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure KonfiKaart (var Konfitav : TKaart; Mitmes : shortint; Vanem : TWinControl);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



const Mastid : array[0..3] of string = ('Risti', 'Ruutu', 'rtu', 'Poti');
      Kaardid : array[0..12] of string = ('kaks', 'kolm', 'neli', 'viis', 'kuus',
              'seitse', 'kaheksa', 'heksa', 'kmme', 'soldat', 'emand', 'kuningas', 'tuus');
      Arvuti = 0;
      Inimene = 1;

var
  Form1: TForm1;
  ArvutiKaardid, InimeseKaardid : array[0..5] of TKaart;
  KaardiPakk : string[51];
  ArvutiEsimesena : boolean;
  PandudKaardiVaartus, PandudKaardiIndex : array[Arvuti..Inimene] of shortint;
  Kaike : shortint;

implementation

{$R *.DFM}



procedure TForm1.PaneArvutiKaart (var Pandav : shortint);
begin
       PandudKaardiVaartus[Arvuti] := ArvutiKaardid[Pandav].Vaartus;
       PandudKaardiIndex[Arvuti] := Pandav;
       ArvutiKaardid[Pandav].Parent := Groupbox3;
       ArvutiKaardid[Pandav].Left := 20;
       ArvutiKaardid[Pandav].OnDragDrop := TihiDragDrop;
       ArvutiKaardid[Pandav].OnDragOver := TihiDragOver;
       ArvutiEsimesena := True;
end;


procedure TForm1.KonfiKaart (var Konfitav : TKaart; Mitmes : shortint; Vanem : TWinControl);
var k : shortint;
    Leitud : boolean;
begin
      repeat
      Leitud := true;
      k := random (52);
      if KaardiPakk[k] = #1 then leitud := false else Kaardipakk[k] := #1;
      until leitud;
      Konfitav := TKaart.Create (Vanem);
      Konfitav.Parent := Vanem;
      Konfitav.Tag  := Mitmes;
      Konfitav.Left := 20 + Mitmes * 56;
      Konfitav.Top := 24;
      Konfitav.Width := 49;
      Konfitav.Height := 73;
      PildiMassiiv.GetBitmap (k, Konfitav.Picture.Bitmap);
      Konfitav.Vaartus := k mod 13;
      Konfitav.Show;
end;


procedure TForm1.Button1Click(Sender: TObject);
var i, k, max : shortint;
begin
     Kaike := 0;
     ArvutiEsimesena := False;
     for i := 0 to 51 do KaardiPakk[i] := #0;
     for i := 0 to 5 do
      begin
      ArvutiKaardid[i].Free;
      InimeseKaardid[i].Free;
      end;
     for i := 0 to 5 do
      begin
      KonfiKaart (ArvutiKaardid[i], i, GroupBox1);
      KonfiKaart (InimeseKaardid[i], i, GroupBox2);
      InimeseKaardid[i].DragMode := dmAutomatic;
      end;
     Label1.Caption := 'Tihid : 0';
     Label2.Caption := 'Tihid : 0';
     If Random(2) = 1 then
       begin
       max := -1;
       for i := 0 to 5 do if ArvutiKaardid[i].Vaartus > max
        then
         begin
         max := ArvutiKaardid[i].Vaartus;
         k := i;
         end;
       PaneArvutiKaart (k);
       end;
end;



procedure TForm1.Button2Click(Sender: TObject);
var i : shortint;
begin
     for i := 0 to 5 do
      begin
      ArvutiKaardid[i].Free;
      InimeseKaardid[i].Free;
      end;
     Form1.Close;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
     Randomize;
end;


procedure TForm1.TihiDragOver (Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
     Self.DragCursor := crDrag;
end;


procedure TForm1.TihiDragDrop (Sender, Source: TObject; X, Y: Integer);
var i, k, l, max, min : shortint;
begin
     If ArvutiEsimesena then
      if TKaart(Source).Vaartus < PandudKaardiVaartus[Arvuti] then
       begin
       for i := 0 to 5 do if not (InimeseKaardid[i] = nil)
           and (InimeseKaardid[i].Vaartus >= PandudKaardiVaartus[Arvuti]) then
        begin
        ShowMessage ('Sa ei tohi kia viksemat kaarti, kui sul on kia suurem vi samavrne kaart.');
        exit;
        end;
       for i := 0 to 5 do if not (InimeseKaardid[i] = nil)
           and (InimeseKaardid[i].Vaartus < TKaart(Source).Vaartus) then
         begin
         ShowMessage ('Kui sul pole suuremat vi vrdset kaarti, pead sa kima oma kige viksema.');
         exit;
         end;
      end;

      TKaart(Source).Parent := GroupBox3;
      If ArvutiEsimesena then TKaart(Source).Left := 76 else TKaart(Source).Left := 20;
      PandudKaardiIndex[Inimene] := TKaart(Source).Tag;
      PandudKaardiVaartus[Inimene] := TKaart(Source).Vaartus;

      if not ArvutiEsimesena then
       begin
       max := -1;
       min := 13;
       for i := 0 to 5 do if not (ArvutiKaardid[i] = nil) then
        begin
        If ArvutiKaardid[i].Vaartus > max then
         begin
         max := ArvutiKaardid[i].Vaartus;
         k := i;
         end;
        If ArvutiKaardid[i].Vaartus < min then
         begin
         min := ArvutiKaardid[i].Vaartus;
         l := i;
         end;
        end;
       if Max >= PandudKaardiVaartus[1] then i := k else i := l;
       ArvutiKaardid[i].Parent := Groupbox3;
       ArvutiKaardid[i].Left := 76;
       PandudKaardiIndex[Arvuti] := i;
       PandudKaardiVaartus[Arvuti] := ArvutiKaardid[i].Vaartus;
       end;

      for i := 0 to Form1.controlcount - 1 do Form1.Controls[i].Enabled := False;
      Timer1.Enabled := True;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var i, TihiSai, l, max : shortint;
begin
     Inc (Kaike);
     If ArvutiEsimesena then
      begin
      If PandudKaardiVaartus[1] >= PandudKaardiVaartus[Arvuti] then TihiSai := Inimene else TihiSai := Arvuti;
      end
     else If PandudKaardiVaartus[Arvuti] >= PandudKaardiVaartus[Inimene] then TihiSai := Arvuti else TihiSai := Inimene;

     ArvutiKaardid[PandudKaardiIndex[Arvuti]].Free;
     InimeseKaardid[PandudKaardiIndex[Inimene]].Free;
     ArvutiKaardid[PandudKaardiIndex[Arvuti]] := Nil;
     InimeseKaardid[PandudKaardiIndex[Inimene]] := Nil;


     If TihiSai = Inimene then
      begin
      Label2.Caption := 'Tihid : ' + IntToStr(StrToInt(Label2.Caption[Length(Label2.Caption)]) + 1);
      ArvutiEsimesena := False;
      end
     else
      begin
      Label1.Caption := 'Tihid : ' + IntToStr(StrToInt(Label1.Caption[Length(Label1.Caption)]) + 1);
      if Kaike < 6 then
       begin
       max := -1;
       for i := 0 to 5 do if not (ArvutiKaardid[i] = nil) then if ArvutiKaardid[i].Vaartus > max
        then
         begin
         max := ArvutiKaardid[i].Vaartus;
         l := i;
         end;
       PaneArvutiKaart (l);
       end;
      end;


     for i := 0 to Form1.ControlCount - 1 do Form1.Controls[i].Enabled := True;
     Timer1.Enabled := False;

     if Kaike = 6 then if TihiSai = Inimene then ShowMessage ('Sa oled kurk!')
                                           else ShowMessage ('Arvuti on kurk!');
end;


end.
