Program LaskeSuusatamine;
{
05.02.1999
Programmi kirjutasid :
         Erkki Lindpere 970750
         Kert  Rungi    970768
         Erki  Suurjaak 970772
         Kaur  Tiitus   970773
LAP41
}


type Voistleja = record
     JrkNumber : integer;
     Nimi : String[20];
     Moodalasud : array[1..4] of byte;
     Tund, Minut, Sekund : byte;
     Katkestas : Boolean;
end;

var Voistlejad : array[1..255] of Voistleja;
    lisa1, lisa2, lisa3, lisa4 : Text;
    max, i, j, tiire, abinr1, abinr2 : Integer;
    abistr : String;


FUNCTION NullEtte (NullAsi : byte) : string;
var NullStr : string;

begin
 Str (NullAsi, NullStr);
 if NullAsi div 10 < 1 then Insert ('0', NullStr, 1);
 NullEtte := NullStr;
end;



PROCEDURE Vaheta (vahetayks, vahetakaks : integer);
var vahetaabi : Voistleja;

begin
     vahetaabi := Voistlejad[Vahetakaks];
     Voistlejad[Vahetakaks] := Voistlejad[Vahetayks];
     Voistlejad[Vahetayks] := vahetaabi;
end;


FUNCTION EesPool (eesyks, eeskaks : integer) : boolean;

begin
 EesPool := false;
 if (Voistlejad[eesyks].Katkestas and not Voistlejad[eeskaks].Katkestas)
  then exit
 else if (not Voistlejad[eesyks].Katkestas and Voistlejad[eeskaks].Katkestas)
  then EesPool := true
 else if (Voistlejad[eesyks].Katkestas and Voistlejad[eeskaks].Katkestas) then
   begin
   if Voistlejad[eesyks].JrkNumber < Voistlejad[eeskaks].JrkNumber then Eespool := True;
   end
 else if
 (Voistlejad[eesyks].Tund * 3600 + Voistlejad[eesyks].Minut * 60 + Voistlejad[eesyks].Sekund)
   <
 (Voistlejad[eeskaks].Tund * 3600 + Voistlejad[eeskaks].Minut * 60 + Voistlejad[eeskaks].Sekund)
 then EesPool := True;
end;


PROCEDURE ShellSort;
var k, l : integer;
    valmis : boolean;

begin
 i := max;
 while i > 1 do
  begin
  i := i div 2;
   repeat
   valmis := true;
   for l := 1 to max - i do
    begin
    k := l + i;
    if Eespool (k, l)
    then
     begin
     vaheta (l, k);
     valmis := false;
     end;
    end;
   until valmis;
  end;
end;



BEGIN
     Assign (lisa1, 'llisa1.txt');
     Assign (lisa2, 'llisa2.txt');
     Assign (lisa3, 'llisa3.txt');
     Assign (lisa4, 'llisa4.txt');
     {$I-}
     Reset (lisa1);
     Reset (lisa2);
     Reset (lisa3);
     Rewrite (lisa4);
     {$I+}
     If IOResult <> 0 then
      begin
      writeln (^G, 'Yhe faili avamisel tekkis torge.');
      Halt (0);
      end;

     repeat
     Read (lisa1, i);
     Read (lisa1, Voistlejad[i].Nimi);
     Voistlejad[i].JrkNumber := i;
     readln (lisa1);
     until eof(lisa1);
     max := i;

     for i := 1 to max do with Voistlejad[i] do
      begin
      Katkestas := True;
      for j := 1 to 4 do Moodalasud[j] := 6;
      end;
     tiire := 0;


    repeat
    inc (tiire);
       repeat
       readln (lisa2, abistr);
       if abistr > '' then
        begin
        Val (Copy (abistr, 1, 2), i, abinr1);
        Val (Copy (abistr, 3, 2), Voistlejad[i].Moodalasud[tiire], abinr1);
        if (tiire = 1) then Voistlejad[i].Katkestas := False
        else if not (Voistlejad[i].Katkestas) then Voistlejad[i].Katkestas := False;
        end;
       until abistr = '';
    for j := 1 to max do if Voistlejad[j].Moodalasud[tiire] > 5
        then Voistlejad[j].Katkestas := True;
    until eof(lisa2);

     repeat
     read (lisa3, i);
     with Voistlejad[i] do if Katkestas then readln (lisa3) else
      begin
      read (lisa3, abistr);
      readln (lisa3);
      Delete (abistr, 1, 1);
      If abistr[2] = ':' then
       begin
       Val(abistr[1], Tund, abinr2);
       Delete (abistr, 1, 2);
       end
      Else Tund := 0;
      Val(abistr[2], Minut, abinr2);
      Val(abistr[1], abinr1, abinr2);
      Minut := Minut + 10 * abinr1;
      Delete (abistr, 1, 3);
      Val(abistr, Sekund, abinr2);
      If Tund = 0 then Dec (Minut, i) else
       begin
       If minut < i then
        begin
        Dec (Tund);
        Minut := Minut + 60 - i;
        end
       else dec (Minut, i - 1);
       for j := 1 to tiire do Dec (Minut, MoodaLasud[j]);
       end;
      Voistlejad[i].Katkestas := False;
      end;
     until eof(lisa3);

     for i := 1 to max do with Voistlejad[i] do if Tund + Minut + Sekund = 0 then Katkestas := True;

     ShellSort;

     writeln (lisa4, '');
     writeln (lisa4, ' # Voistleja nimi       Moodalasud   Lopetamisaeg');
     writeln (lisa4, '');

     For i := 1 to max do with Voistlejad[i] do
      begin
      write (lisa4, Voistlejad[i].JrkNumber:2);
      write (lisa4, Nimi, '':(20 - Length(nimi)));
      for j := 1 to tiire do
       begin
       if Moodalasud[j] < 6 then write (lisa4, Moodalasud[j]:3)
          else write (lisa4, 'K':3);
       end;
      for j := tiire + 1 to 4 do write (lisa4, ' ':3);
      If Voistlejad[i].Katkestas or (Tund + Minut + Sekund = 0) then
       writeln (lisa4, 'Katkestas':12)
      else
       writeln (lisa4, NullEtte(Tund):5, ':', NullEtte(Minut), ':', NullEtte(Sekund));
      end;

     Close (lisa1);
     Close (lisa2);
     Close (lisa3);
     Close (lisa4);
END.
