Unit Prog2_5M;

{
Pimepuu moodul
Programmeerimine II
5. lesanne
Erki Suurjaak
970772
LAP41
20.02.1999
}


INTERFACE


TYPE PoimPuu = ^Solm;


     Solm = RECORD
     Vaartus : word;
     Kordsus : word;
     Poimitud : Boolean;
     Vasak   : PoimPuu;
     Parem   : PoimPuu;
     END;


PROCEDURE TeeTyhiPuu (Var Vark : PoimPuu);
PROCEDURE LisaElement (Var Vark : PoimPuu; Lisatav : Word);
FUNCTION  ElementPuus (var Vark : PoimPuu; Element : Word) : Boolean;
FUNCTION LoendaElemendid (var Vark : PoimPuu) : word;
PROCEDURE ValjastaInOrder (var Vark : PoimPuu);
PROCEDURE KustutaElemendid (var Vark : PoimPuu);



IMPLEMENTATION



PROCEDURE TeeTyhiPuu;

begin
     Vark := Nil;
end;


PROCEDURE LooSolm (var Loodav : PoimPuu; LoodavaVaartus : word);

begin
     New (Loodav);
     Loodav^.Vasak := Nil;
     Loodav^.Parem := Nil;
     Loodav^.Kordsus := 1;
     Loodav^.Vaartus := LoodavaVaartus;
     Loodav^.Poimitud := True;
end;


PROCEDURE LisaElement;
var UusSolm, HetkSolm : PoimPuu;

begin
     if Vark = Nil then
      begin
      LooSolm (UusSolm, Lisatav);
      Vark := UusSolm;
      exit;
      end;

     HetkSolm := Vark;
     while True do
     begin
      if Lisatav < HetkSolm^.Vaartus then
       begin
       if (HetkSolm^.Vasak <> Nil) then HetkSolm := HetkSolm^.Vasak
       else
        begin
        LooSolm (UusSolm, Lisatav);
        HetkSolm^.Vasak := UusSolm;
        UusSolm^.Parem := HetkSolm;
        Exit;
        end;
       end
      else if Lisatav > HetkSolm^.Vaartus then
       begin
       if (HetkSolm^.Parem = Nil) then
        begin
        LooSolm (UusSolm, Lisatav);
        UusSolm^.Parem := HetkSolm^.Parem;
        HetkSolm^.Parem := UusSolm;
        HetkSolm^.Poimitud := False;
        Exit;
        end
       else if not HetkSolm^.Poimitud then HetkSolm := HetkSolm^.Parem
       else
        begin
        LooSolm (UusSolm, Lisatav);
        UusSolm^.Parem := HetkSolm^.Parem;
        HetkSolm^.Parem := UusSolm;
        HetkSolm^.Poimitud := False;
        Exit;
        end;
       end
      else
       begin
       Inc (HetkSolm^.Kordsus);
       Exit;
       end
      end;
end;


FUNCTION ElementPuus;
var Abi1 : PoimPuu;

begin
     Abi1 := Vark;
     ElementPuus := False;
     While true do
      begin
      if Abi1 = nil then exit;
      If (Element > Abi1^.Vaartus) and (Abi1^.Poimitud) then exit;
      While (Element < Abi1^.Vaartus) and (Abi1 <> nil) do Abi1 := Abi1^.Vasak;
      While (Element > Abi1^.Vaartus) and (Abi1 <> nil)
       and not (Abi1^.Poimitud) do Abi1 := Abi1^.Parem;
      if Element = Abi1^.Vaartus then
       begin
       ElementPuus := True;
       Exit;
       end;
      end;
end;


PROCEDURE ValjastaInOrder;
var Abi1, Abi2 : PoimPuu;

begin
     Abi1 := Vark;
     while True do
      begin
      Abi2 := Nil;
      While Abi1 <> Nil do
       begin
       Abi2 := Abi1;
       Abi1 := Abi1^.Vasak;
       end;
      If Abi2 = Nil then exit;
      Writeln (Abi2^.Vaartus:5, '*', Abi2^.Kordsus);
      Abi1 := Abi2^.Parem;
      While Abi2^.Poimitud and (Abi1 <> Nil) do
       begin
       Writeln (Abi1^.Vaartus:5, '*', Abi1^.Kordsus);
       Abi2 := Abi1;
       Abi1 := Abi2^.Parem;
       end;
      end;
end;


FUNCTION LoendaElemendid;
var Abi1, Abi2 : PoimPuu;
    Elemente : word;
begin
     Elemente := 0;
     Abi1 := Vark;
     while True do
      begin
      Abi2 := Nil;
      While Abi1 <> Nil do
       begin
       Abi2 := Abi1;
       Abi1 := Abi1^.Vasak;
       end;
      If Abi2 = Nil then
       begin
       LoendaElemendid := Elemente;
       exit;
       end;
      Inc (Elemente);
      Abi1 := Abi2^.Parem;
      While Abi2^.Poimitud and (Abi1 <> Nil) do
       begin
       Inc (Elemente);
       Abi2 := Abi1;
       Abi1 := Abi2^.Parem;
       end;
      end;
end;


PROCEDURE Kinga (var Antav : PoimPuu);
begin
     Dispose (Antav);
     Antav := Nil;
end;


PROCEDURE KustutaElemendid;
var Abi1, Abi2, Abi3 : PoimPuu;

procedure HavitaVasak;
var Buul : boolean;
begin
       Abi1 := Vark^.Vasak;
       while True do
       begin
       Abi2 := nil;
       While Abi1 <> Nil do
        begin
        Abi2 := Abi1;
        Abi1 := Abi1^.Vasak;
        end;

       if Abi2 = nil then exit;
       Buul := false;
       Abi1 := Abi2^.Parem;
       if Abi2^.Poimitud then
        begin
        Kinga (Abi2);
        Buul := True;
        end;
       if Abi1 = Vark then exit;

       if not Abi1^.Poimitud then Abi1 := Abi1^.Parem else
        begin
        Abi3 := Abi2;
        Abi2 := Abi1^.Parem;
        Kinga (Abi1);
        Abi2^.Vasak := nil;
        Abi1 := Abi2;
        if Abi1 = Vark then if Abi1^.Vasak = nil then exit else Abi1 := Abi1^.Vasak;
        if not Buul then
         begin
         Abi3^.Parem := Abi2;
         Abi3^.Poimitud := True;
         end;
        end
       end;
end;

procedure HavitaParem;
begin
       Abi1 := Vark^.Parem;
       while true do
        begin
        Abi2 := nil;
        While Abi1 <> Nil do
         begin
         Abi2 := Abi1;
         Abi1 := Abi1^.Vasak;
         end;

        if Abi2 = nil then exit;

        Abi1 := Abi2^.Parem;
        if Abi2^.Poimitud then Kinga (Abi2);
        if Abi1 = nil then exit;

        if not Abi1^.Poimitud then Abi1 := Abi1^.Parem else
         begin
         Abi3 := Abi2;
         Abi2 := Abi1^.Parem;
         Kinga (Abi1);
         Abi1 := Abi2;
         if Abi1 = nil then exit;
         Abi3^.Parem := Abi2;
         Abi3^.Poimitud := True;
         end
       end;
end;


begin
     If Vark = nil then exit;
     If Vark^.Vasak <> Nil then HavitaVasak;
     If Vark^.Parem <> nil then HavitaParem;
     Kinga (Vark);
end;



END.

